(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is CodeEditorFormUnit.pas

The Initial Developer of the Original Code is
Florian Kberle. (eMail:FloriansKarten@web.de)
Portions created by the Initial Developer are Copyright (C) 2005
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)

unit CodeEditorFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActnList, Menus, CodeEditor, StdActns, ComCtrls,WortErkennungsUnit;
const
  WM_PARAMETER=WM_USER+253;
type
  TWMParameter = packed record
    Msg: Cardinal;
    AtomID:ATOM;
    Unused:Word;
    Size:Longint;
    Result: Longint;
  end;

type
  TFloriansCodeEditorForm = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Speichern1: TMenuItem;
    Laden1: TMenuItem;
    Speichernunter1: TMenuItem;
    Schlieen1: TMenuItem;
    ProgrammBeenden1: TMenuItem;
    ActionList1: TActionList;
    Action_Open: TAction;
    Action_Close: TAction;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Action_Save: TAction;
    Action_SaveTo: TAction;
    Action_Exit: TAction;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditDelete1: TEditDelete;
    EditPaste1: TEditPaste;
    EditSelectAll1: TEditSelectAll;
    EditUndo1: TEditUndo;
    Bearbeiten1: TMenuItem;
    MenuItem_Undo: TMenuItem;
    MenuItem_Repeat: TMenuItem;
    EditRepeat1: TAction;
    MenuItem_Copy: TMenuItem;
    MenuItem_Cut: TMenuItem;
    MenuItem_Insert: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Hilfe1: TMenuItem;
    About1: TMenuItem;
    About: TAction;
    Action_New: TAction;
    ActionNew1: TMenuItem;
    CEConfig1: TCodeEditorConfig;
    PopupMenu1: TPopupMenu;
    Schlieen2: TMenuItem;
    Neu1: TMenuItem;
    N4: TMenuItem;
    StatusBar1: TStatusBar;
    Lschen1: TMenuItem;
    Allesmarkieren1: TMenuItem;
    N5: TMenuItem;
    Spezial_IncreaseTabs: TAction;
    Spezial_DecreaseTabs: TAction;
    Spezial1: TMenuItem;
    SpezialDecreaseTabs1: TMenuItem;
    SpezialIncreaseTabs1: TMenuItem;
    N6: TMenuItem;
    Action_Export_Wiki: TAction;
    Export1: TMenuItem;
    Wiki1: TMenuItem;
    PageControl1: TPageControl;
    Action_CopyAs_WikiCode: TAction;
    Kopierenals1: TMenuItem;
    WikiHTMLCode1: TMenuItem;
    Action_Export_XML: TAction;
    Action_CopyAs_XMLCode: TAction;
    XML1: TMenuItem;
    XMLCode1: TMenuItem;
    Menu_Suche: TMenuItem;
    Menu_Suchen: TMenuItem;
    Action_Suchen: TAction;
    Action_Weitersuchen: TAction;
    Weitersuchen1: TMenuItem;
    Action_Choose_Delphi: TAction;
    Action_Choose_XML: TAction;
    Highlighter1: TMenuItem;
    Delphi1: TMenuItem;
    ActionChooseXML1: TMenuItem;
    Extra1: TMenuItem;
    XML2: TMenuItem;
    Umlauteersetzen1: TMenuItem;
    Action_Extra_Umlaute_ersetzen: TAction;
    Action_Ersetzen: TAction;
    Ersetzen1: TMenuItem;
    procedure Action_OpenExecute(Sender: TObject);
    procedure Action_SaveToExecute(Sender: TObject);
    procedure Action_SaveExecute(Sender: TObject);
    procedure Action_ExitExecute(Sender: TObject);
    procedure Action_CloseExecute(Sender: TObject);
    procedure EditUndo1Execute(Sender: TObject);
    procedure Bearbeiten1Click(Sender: TObject);
    procedure EditRepeat1Execute(Sender: TObject);
    procedure EditCopy1Execute(Sender: TObject);
    procedure EditCut1Execute(Sender: TObject);
    procedure EditDelete1Execute(Sender: TObject);
    procedure EditPaste1Execute(Sender: TObject);
    procedure AboutExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Action_configExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Action_NewExecute(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure CEConfig1CurPosChange(Sender: TCodeEditor; X, Y: Integer);
    procedure EditSelectAll1Execute(Sender: TObject);
    procedure Spezial_IncreaseTabsExecute(Sender: TObject);
    procedure Spezial_DecreaseTabsExecute(Sender: TObject);
    procedure Action_Export_WikiExecute(Sender: TObject);
    procedure Action_CopyAs_WikiCodeExecute(Sender: TObject);
    procedure Action_Export_XMLExecute(Sender: TObject);
    procedure Action_CopyAs_XMLCodeExecute(Sender: TObject);
    procedure Action_SuchenExecute(Sender: TObject);
    procedure Action_WeitersuchenExecute(Sender: TObject);
    procedure Action_Choose_DelphiExecute(Sender: TObject);
    procedure Action_Choose_XMLExecute(Sender: TObject);
    procedure Action_Extra_Umlaute_ersetzenExecute(Sender: TObject);
    procedure Action_ErsetzenExecute(Sender: TObject);
  private
    procedure WMParameter(var Message:TWMParameter);message WM_PARAMETER;
    procedure Parameterbehandeln(const S:String);

    { Private-Deklarationen }
  public
    function GetActiveCodeEditor:TCodeEditor;
    property ActiveCodeEditor:TCodeEditor read GetActiveCodeEditor;
    { Public-Deklarationen }
  end;
var
  FloriansCodeEditorForm: TFloriansCodeEditorForm;
  UnbekanntIndex:Integer=1;


resourcestring
  EditorName='Florians Code-Editor v1.2.16' ;
  NoFile= 'Unbenannt';
implementation
  uses FindDialogUnit, ReplaceDialogUnit;
  // Diese Kommentar Zeilen galten der Funktion vom Tool GExperts
  {#BACKUP C:\Programme\Borland\Delphi5\DPK-Ordner\Extras\CodeEditor.pas}
  {#BACKUP C:\Programme\Borland\Delphi5\DPK-Ordner\Extras\CodeEditor_DelphiEditors.pas}
  {#BACKUP C:\Programme\Borland\Delphi5\DPK-Ordner\Extras\WortErkennungsUnit.pas}
  {#BACKUP C:\Programme\Borland\Delphi5\DPK-Ordner\Extras\CodeEditor_Hint.pas}
  {#BACKUP Config.txt}
  {#BACKUP Readme.txt}


{$R *.DFM}
procedure TFloriansCodeEditorForm.WMParameter(var Message:TWMParameter);
var
 Text:ShortString;
begin
  GlobalGetAtomName(Message.AtomID,@Text[1],255);
  SetLength(Text, Message.Size) ;//Gre bernehmen
  Parameterbehandeln(Text);
  Message.Result := 1;
end;

function TFloriansCodeEditorForm.GetActiveCodeEditor:TCodeEditor;
begin
  if PageControl1.ActivePage <> nil then
   result := TCodeEditor(PageControl1.ActivePage.Tag)
  else
   raise Exception.Create('Kein Code-Editor ist geffnet!' );
end;
procedure TFloriansCodeEditorForm.Action_OpenExecute(Sender: TObject);
var
  I:Integer;
begin
 //if LoadedFile <> NoFile then if MessageDlg('Sie haben schon eine Datei offen, wollen sie trotzdem weitermachen?', mtConfirmation, [mbOK,mbCancel], 0) = mrCancel then exit;
 if not OpenDialog1.Execute  then exit;

 //Leere nicht bearbeite Standart Seite schlieen.
 if  (OpenDialog1.Files.Count > 0)
 and (PageControl1.PageCount = 1)
 and (ActiveCodeEditor.LoadedFile = NoFile)
 and not(ActiveCodeEditor.UndoList.CanUndo or  ActiveCodeEditor.RepeatList.CanUndo) //Ist etwas verndert worden
 then  PageControl1.ActivePage.free;

 for I := 0 to OpenDialog1.Files.Count-1 do
 begin
   Action_NewExecute(Sender);
   ActiveCodeEditor.Load(OpenDialog1.files[I]);
   PageControl1.ActivePage.Caption :=  ExtractFileName(OpenDialog1.files[I]);
 end;

end;

procedure TFloriansCodeEditorForm.Action_SaveToExecute(Sender: TObject);
begin
 if not SaveDialog1.Execute then exit;

 ActiveCodeEditor.Lines.SaveToFile(SaveDialog1.filename);
 ActiveCodeEditor.LoadedFile := SaveDialog1.filename;
 PageControl1.ActivePage.Caption := ExtractFileName(SaveDialog1.filename);
end;

procedure TFloriansCodeEditorForm.Action_SaveExecute(Sender: TObject);
begin
 if ActiveCodeEditor.LoadedFile = NoFile then
  Action_SaveToExecute(Sender)
 else
  ActiveCodeEditor.Lines.SaveToFile(ActiveCodeEditor.LoadedFile);
end;

procedure TFloriansCodeEditorForm.Action_ExitExecute(Sender: TObject);
var
  I:Integer;
begin
 for I := PageControl1.PageCount-1  downto 0 do Action_CloseExecute(Sender);
 close;
end;

procedure TFloriansCodeEditorForm.Action_CloseExecute(Sender: TObject);
begin
  //Ist etwas verndert worden
  if (ActiveCodeEditor.UndoList.CanUndo or  ActiveCodeEditor.RepeatList.CanUndo)then
  if (ActiveCodeEditor.LoadedFile <> NoFile) then //Ist die Datei schon vorhanden
  begin
    case MessageDlg('Wollen sie ihre nderungen in "' +PageControl1.ActivePage.Caption + '" speichern?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
      mrYes: Action_SaveExecute(Sender);
      mrCancel: exit;
    end;
  end
  else
  begin
    case MessageDlg('Wollen sie "' +PageControl1.ActivePage.Caption + '" speichern?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
      mrYes: Action_SaveExecute(Sender);
      mrCancel: exit;
    end;
  end;
  PageControl1.ActivePage.Free;
  if PageControl1.PageCount = 0 then Action_NewExecute(Sender);//Mindestens eine Datei muss geffnent sein
end;

procedure TFloriansCodeEditorForm.EditUndo1Execute(Sender: TObject);
begin
  ActiveCodeEditor.UndoList.Undo;
end;

procedure TFloriansCodeEditorForm.Bearbeiten1Click(Sender: TObject);
begin
 MenuItem_Undo.Enabled :=  ActiveCodeEditor.UndoList.CanUndo;
 MenuItem_Repeat.Enabled := ActiveCodeEditor.RepeatList.CanUndo;
end;

procedure TFloriansCodeEditorForm.EditRepeat1Execute(Sender: TObject);
begin
  ActiveCodeEditor.RepeatList.Undo;
end;

procedure TFloriansCodeEditorForm.EditCopy1Execute(Sender: TObject);
begin
  SendMessage(ActiveCodeEditor.handle,WM_COPY,0,0);
end;

procedure TFloriansCodeEditorForm.EditCut1Execute(Sender: TObject);
begin
  SendMessage(ActiveCodeEditor.handle,WM_CUT,0,0);
end;

procedure TFloriansCodeEditorForm.EditDelete1Execute(Sender: TObject);
begin
  SendMessage(ActiveCodeEditor.handle,WM_CLEAR,0,0);
end;

procedure TFloriansCodeEditorForm.EditPaste1Execute(Sender: TObject);
begin
  SendMessage(ActiveCodeEditor.handle,WM_PASTE,0,0);
end;

procedure TFloriansCodeEditorForm.AboutExecute(Sender: TObject);
begin
  ShowMessage('Diese Version ist Freeware'+ #10#13#10#13  + 'Fr evtl. entstehende Schden berneheme ich keine Haftung'+#10#13+#10#13+ 'All Copyrights by Florian Kberle'+ #10#13+'(eMail: FloriansKarten@web.de)');
end;

procedure TFloriansCodeEditorForm.FormCreate(Sender: TObject);
begin
  FloriansCodeEditorForm.Caption := EditorName;

end;

procedure TFloriansCodeEditorForm.Action_configExecute(Sender: TObject);
begin
(*
var
  ConfigDialog:TConfigDialog;
begin
  ConfigDialog := TConfigDialog.Create(Application);
  try
    ConfigDialog.Data := CodeEditor1.Config;
    ConfigDialog.ShowModal;
  finally
    ConfigDialog.free;
  end;*)
end;
procedure TFloriansCodeEditorForm.Parameterbehandeln(const S:String);
begin
  if FileExists(S) then
  begin
    Action_NewExecute(self);
    ActiveCodeEditor.Load(S);
    PageControl1.ActivePage.Caption :=  ExtractFileName(S);
  end;
end;
procedure TFloriansCodeEditorForm.FormShow(Sender: TObject);
var
  I:Integer;
begin
  for I := 1 to ParamCount do  Parameterbehandeln(Paramstr(I));
  if PageControl1.PageCount = 0 then Action_NewExecute(Self)
end;

procedure TFloriansCodeEditorForm.Action_NewExecute(Sender: TObject);
var
  NewTapSheet:TTabSheet;
  NewCodeEditor:TCodeEditor;
begin
  NewTapSheet :=  TTabSheet.Create(PageControl1);
  NewTapSheet.PageControl := PageControl1;
  NewCodeEditor := TCodeEditor.CreateC(NewTapSheet,CEConfig1);
  NewTapSheet.Caption := NoFile + ' ' + inttostr(UnbekanntIndex);
  NewTapSheet.tag := Integer(NewCodeEditor);
  NewCodeEditor.Parent := NewTapSheet;
  NewCodeEditor.Align := alClient;
  NewCodeEditor.LoadedFile := NoFile;
  StatusBar1.Panels[0].text := '0 / 0';
  PageControl1.ActivePageIndex := NewTapSheet.PageIndex;
  Inc(UnbekanntIndex);
end;

procedure TFloriansCodeEditorForm.PageControl1Change(Sender: TObject);
begin
   ActiveCodeEditor.ShowNewCurPos;
end;

procedure TFloriansCodeEditorForm.CEConfig1CurPosChange(Sender: TCodeEditor; X, Y: Integer);
begin
  if Sender = ActiveCodeEditor then
  begin
    StatusBar1.Panels[0].Text :=  inttostr(X) + ' / ' + inttostr(Y) ;
  end;
end;

procedure TFloriansCodeEditorForm.EditSelectAll1Execute(Sender: TObject);
begin
  ActiveCodeEditor.Menu_SelectAll;
end;

procedure TFloriansCodeEditorForm.Spezial_IncreaseTabsExecute(Sender: TObject);
begin
  ActiveCodeEditor.Menu_IncreaseTabs;
end;

procedure TFloriansCodeEditorForm.Spezial_DecreaseTabsExecute(Sender: TObject);
begin
  ActiveCodeEditor.Menu_DecreaseTabs;
end;

procedure TFloriansCodeEditorForm.Action_Export_WikiExecute(Sender: TObject);
begin
  SaveDialog1.DefaultExt := 'txt';
  if SaveDialog1.Execute then ActiveCodeEditor.Menu_Export_Wiki(SaveDialog1.filename);
end;

procedure TFloriansCodeEditorForm.Action_CopyAs_WikiCodeExecute(Sender: TObject);
begin
  ActiveCodeEditor.Menu_CopyAs_WikiCode;
end;

procedure TFloriansCodeEditorForm.Action_Export_XMLExecute(
  Sender: TObject);
begin
  SaveDialog1.DefaultExt := 'xml';
  if SaveDialog1.Execute then ActiveCodeEditor.Menu_Export_XML(SaveDialog1.filename);
end;

procedure TFloriansCodeEditorForm.Action_CopyAs_XMLCodeExecute(
  Sender: TObject);
begin
  ActiveCodeEditor.Menu_CopyAs_XMLCode;
end;

procedure TFloriansCodeEditorForm.Action_SuchenExecute(Sender: TObject);
begin
    FindForm.ShowModal;
end;

procedure TFloriansCodeEditorForm.Action_WeitersuchenExecute(
  Sender: TObject);
begin
 Weitersuchen;
end;

procedure TFloriansCodeEditorForm.Action_Choose_DelphiExecute(
  Sender: TObject);
begin
  ActiveCodeEditor.Menu_SetQuelltextTyp(TDelphiQuelltext);
end;

procedure TFloriansCodeEditorForm.Action_Choose_XMLExecute(
  Sender: TObject);
begin
  ActiveCodeEditor.Menu_SetQuelltextTyp(TXMLQuelltext);
end;

procedure TFloriansCodeEditorForm.Action_Extra_Umlaute_ersetzenExecute(
  Sender: TObject);
begin
  ActiveCodeEditor.Menu_Extra_XML_Umlaute_ersetzen;
end;

procedure TFloriansCodeEditorForm.Action_ErsetzenExecute(Sender: TObject);
begin
  ReplaceForm.ShowModal;
end;

end.
