(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is CodeEditor_Projekt.dpr

The Initial Developer of the Original Code is
Florian Kberle. (eMail:FloriansKarten@web.de)
Portions created by the Initial Developer are Copyright (C) 2005
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)

program CodeEditor_Projekt;

uses
  Forms,
  Windows,
  Messages,
  SysUtils,
  CodeEditorFormUnit in 'CodeEditorFormUnit.pas' {FloriansCodeEditorForm},
  FindDialogUnit in 'FindDialogUnit.pas' {FindForm},
  ReplaceDialogUnit in 'ReplaceDialogUnit.pas' {ReplaceForm};

{$R *.RES}
               

var
  MutexHandle: THandle;
  Window:HWND;

procedure SendeParameter;
var
  Text:ShortString;
  I:Integer;
  TextAtom:ATOM;
begin
  for I := 1 to ParamCount do
  begin
    if length(ParamStr(I))+1 > 255 then raise Exception.Create('Parameter Gre bersteigt das Maximum von 255');
    Text:=ParamStr(I);
    TextAtom := GlobalAddAtom(@Text[1]);
    if SendMessage(Window,WM_PARAMETER,wParam(TextAtom),lParam(length(Text))) = 0 then
    begin
      //Text fr Fehlermeldung ermitteln
      GetWindowText(Window,@Text[1],255);
      SetLength(Text,GetWindowTextLength(Window));
      //Fehlermeldung ausgeben
      raise Exception.Create('Akiver Code-Editor "'+Text+ '" antwortet nicht');
    end;
    // MessageBox(0, 'Eine laufende Version des Code-Editors konnte die bermittelten Daten nicht verarbeiten.', 'Hinweis', MB_ICONWARNING or MB_OK);
    GlobalDeleteAtom(TextAtom);
  end;
end;


begin
  MutexHandle := CreateMutex(nil, TRUE, 'FloriansCodeEditorAktiv');
  if MutexHandle <> 0 then
  begin
    if GetLastError = ERROR_ALREADY_EXISTS then
    begin
      Window := FindWindow('TFloriansCodeEditorForm',nil);
      if Window <> 0 then
      begin
        SendeParameter;
        CloseHandle(MutexHandle);
        SetForegroundWindow(Window);
        Halt;
      end;
    end;
    Application.Initialize;
    Application.Title := 'Code-Editor';
    Application.CreateForm(TFloriansCodeEditorForm, FloriansCodeEditorForm);
  Application.CreateForm(TFindForm, FindForm);
  Application.CreateForm(TReplaceForm, ReplaceForm);
  Application.Run;
    if MutexHandle <> 0 then CloseHandle(MutexHandle);
  end;
end.
