(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is CodeEditorConst.pas

The Initial Developer of the Original Code is
Florian Kberle. (eMail:FloriansKarten@web.de)
Portions created by the Initial Developer are Copyright (C) 2005
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)

unit CodeEditorConst;
interface
uses Graphics; //Fr die Farben
const
  HighColorIndex=11;

  CI_Normal=0;
  CI_Ausdruck=1;
  CI_Kommentar=2;
  CI_String=3;
  CI_Klammer0=4;
  CI_Klammer1=5;
  CI_Klammer2=6;
  CI_Compiler=7;
  CI_GExperts=8;

  CI_XML_OpenTag_Klammer=9; //  z.B.: "<"Irgendwas">"  oder "<" Irgendwas />
  CI_XML_CloseTag_Klammer=10; //  z.B.: "</"Irgendwas">"  oder < Irgendwas "/>"
  CI_XML_Eigenschaft=11; // z.B.: < Irgendwas "Irgendwas2"=

  CI_Fehler=0;
  CI_CodeEditor_Normal=8;
  CI_CodeEditor_Ausdruck=8;
type
  TLoadConifgReaktion=set of (LCR_NeuZeichnen,LCR_UpdateQuelltext);

  TCIColors= array [0..HighColorIndex] of TColor;
  TCIStyles= array [0..HighColorIndex] of TFontStyles;


var
  StdColorNr:TCIColors;
  StdStyleNr:TCIStyles;
const
  StdLeerzeichenProTap=2;
  //Fr XML-Export
  CIName: array [0..HighColorIndex] of String = (
                                                 'normal',
                                                 'keyword',//Ausdruck
                                                 'comment',//Kommentar
                                                 'string',
                                                 'bracket0',//KlammerA
                                                 'bracket1',//KlammerB
                                                 'bracket2',//KlammerC
                                                 'comment',//Compiler
                                                 'comment',//EditorHinweis
                                                 'normal', // CI_XML_OpenTag_Klammer    - Vorlufig
                                                 'normal', // CI_XML_CloseTag_Klammer   - Vorlufig
                                                 'normal' // CI_XML_Eigenschaft    - Vorlufig
                                                 );


implementation

initialization
  // Standart Farben ber Index Konstanten festlegen
  StdColorNr[CI_Normal] := clWindowText;
  StdColorNr[CI_Ausdruck] := clWindowText;
  StdColorNr[CI_Kommentar] := clNavy; //Dunkelblau
  StdColorNr[CI_String] := clMaroon;//Braun-Rot
  StdColorNr[CI_Klammer0] := clBlack;
  StdColorNr[CI_Klammer1] := clGreen;
  StdColorNr[CI_Klammer2] := clFuchsia;
  StdColorNr[CI_Compiler] := clRed;
  StdColorNr[CI_GExperts] := clFuchsia;

  StdColorNr[CI_XML_OpenTag_Klammer] := clGreen;
  StdColorNr[CI_XML_CloseTag_Klammer] := clRed;
  StdColorNr[CI_XML_Eigenschaft] := clBlue;




  // Standart FontStyles ber Index Konstanten festlegen
  StdStyleNr[CI_Normal] := [];
  StdStyleNr[CI_Ausdruck] := [fsBold];
  StdStyleNr[CI_Kommentar] := [fsItalic];
  StdStyleNr[CI_String] := [];
  StdStyleNr[CI_Klammer0] := [fsBold];
  StdStyleNr[CI_Klammer1] := [fsBold];
  StdStyleNr[CI_Klammer2] := [fsBold];
  StdStyleNr[CI_Compiler] := [fsItalic];
  StdStyleNr[CI_GExperts] := [fsItalic];

  StdStyleNr[CI_XML_OpenTag_Klammer] := [];
  StdStyleNr[CI_XML_CloseTag_Klammer] := [];
  StdStyleNr[CI_XML_Eigenschaft] := [fsBold];

end.
