(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is CodeEditor_Hint.pas

The Initial Developer of the Original Code is
Florian Kberle. (eMail:FloriansKarten@web.de)
Portions created by the Initial Developer are Copyright (C) 2005
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)

unit CodeEditor_Hint;

interface
uses Windows,Forms,classes,Graphics;
type
THintStrings=array of array of String;

THintForm=class(TCustomForm)
private

protected
  procedure CreateWnd; override;
  procedure Paint; override;
public
  Hint:THintStrings;
  BoldIndex:Integer;
  procedure ShowHint(Bold:Integer;X,Y:Integer);
  procedure MoveTo(X,Y:Integer);

end;

implementation
const
 HighTestString='AgJIl';

procedure THintForm.CreateWnd;
begin
 inherited;
 BorderStyle := bsnone;
 Color := clInfoBK;
 SetWindowPos(Handle,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE );
end;

procedure THintForm.ShowHint(Bold:Integer;X,Y:Integer);
var
 AktivesFenster:HWND;
begin
 AktivesFenster := GetActiveWindow;
 BoldIndex  := Bold;
 Height:= length(Hint) * (Canvas.TextHeight(HighTestString)+1) +1;
 Top := Y;
 Left := X;
 if Left + Width > Screen.Width then Left := Screen.Width - Width;
 Show;
 SetActiveWindow(AktivesFenster);
end;

procedure THintForm.MoveTo(X,Y:Integer);
begin
 Top := Y;
 Left := X;
 if Left + Width > Screen.Width then Left := Screen.Width - Width;
end;

procedure THintForm.Paint;
var
  X,Y:Integer;
  I:Integer;
begin
 inherited;
 Canvas.Pen.Color := clgray;
 Canvas.Brush.Color := Color;
 Canvas.Rectangle(0,0,width,height);
 Canvas.Pen.Color := clsilver ;
 Canvas.MoveTo(0,height-1);
 Canvas.LineTo(0,0);
 Canvas.LineTo(width,0);
 for Y := 0 to high(Hint) do
 begin
  I := 0;
  for X := 0 to high(Hint[Y]) do
  begin
   if BoldIndex = X then Canvas.Font.Style :=  [fsBold] else Canvas.Font.Style := [];
   Canvas.TextOut(2+I,1+Y*Canvas.TextHeight(HighTestString),Hint[Y,X]);
   I := I + Canvas.TextWidth(Hint[Y,X]);
  end;
 end;
end;
end.
