unit WortErkennungsUnit;

(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is WortErkennungsUnit.pas

The Initial Developer of the Original Code is
Florian Kberle. (eMail:FloriansKarten@web.de)
Portions created by the Initial Developer are Copyright (C) 2005
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)

interface
uses sysutils,Classes,CodeEditorConst;//Fr TStrings;
{$DEFINE ERRORCHECK}
type
  //TCodeType=(ctDelphi);
  TWort = record
    Text : String ;
    Anfang : Integer;
    FontIndex:Byte;
  end;
  TZeile=array of TWort;

  (*
  TZeilenInfo= record
    CanExpand:Boolean;
    Zusammengefasst:Boolean;
    Anzahl:Integer;//Wieviel Zeilen sollen ausgeblendet werden.
  end;  *)
type
  TUnusedParams=array [0..1] of Integer;

 TZeilenInfo= record
   OpenBracket:Integer;//Aktueller Klammer Stand muss nicht genutzt werden
   NextLine:Integer;//Gibt indirekt an ob minimiert wurde
   Owner:Integer;//Zeile die fr diese steht
   BlockTyp:Byte;// Gibt an ob und wie die Zeile Minimiert werden kann (Typ <> 0 -> kann minimiert werden)
   KMode:Byte;//Kann fr Kommentar Speicherungen genutzt werden
   Unused: TUnusedParams;
 end;

 TQuelltext = class
  protected
    function FindNextLine(const Index:Integer):Integer; virtual;//Sucht nach dem passenden End
  public
    Zeilen:array of TZeile;
    ZeilenInfo:array of TZeilenInfo;
    Constructor Create(const Strings:TStrings); virtual;
    procedure WortErmittlung(var Zeile:TZeile;const S:String); virtual; abstract;
    procedure WortErkennung(const Von,Bis:Integer);
    procedure WortErkennungBeiZeile(var Zeile:TZeile;var OpenBracket:Integer;var KMode:Byte; out BlockTyp:Byte; out Unused:TUnusedParams); virtual; abstract;
    procedure InsertLines(const Index,Anzahl:Integer);virtual;
    procedure DeleteLines(const Index,Anzahl:Integer);virtual;
    function CanMinimize(Y:Integer):Boolean;virtual;
    function GetNextLine(Y:Integer):Integer;
    function IsMinimized(const Y:Integer):Boolean;
    procedure Expand(const Enabled:Boolean;Y:Integer);
    function GetLineOwner(const Y:Integer):Integer;
 end;
 TQuelltextKlasse = class of TQuelltext;

 TXMLQuelltext = class(TQuelltext)
  public
    procedure WortErkennungBeiZeile(var Zeile:TZeile;var OpenBracket:Integer;var KMode:Byte; out BlockTyp:Byte; out Unused:TUnusedParams); override;
    procedure WortErmittlung(var Zeile:TZeile;const S:String); override;
 end;


 TDelphiQuelltext = class(TQuelltext)
  public
    procedure WortErkennungBeiZeile(var Zeile:TZeile;var OpenBracket:Integer;var KMode:Byte; out BlockTyp:Byte; out Unused:TUnusedParams); override;
    procedure WortErmittlung(var Zeile:TZeile;const S:String); override;
    function FindNextLine(const Index:Integer):Integer; override; //Sucht nach dem passenden Ende
    function FindNextend(const Index:Integer):Integer; //Sucht nach dem Ende end
    function FindNextendregion(const Index:Integer):Integer; //Sucht nach dem Ende EndRegion
 end;

  TStringLib=class
  protected
    StringNr:array of String;
    procedure Sort;
    function IndexOf(const S:String):Integer;
  end;

implementation

uses
  Windows;


const
  SChar:array [Char] of Char=(
                              #0,#1,#2,#3,#4,#5,#6,#7,#8,#9,#10,#11,#12,#13,#14,#15,
                              #16,#17,#18,#19,#20,#21,#22,#23,#24,#25,#26,#27,#28,#29,#30,#31,
                              #32,#33,#34,#35,#36,#37,#38,#39,#40,#41,#42,#43,#44,#45,#46,#47,
                              #48,#49,#50,#51,#52,#53,#54,#55,#56,#57,#58,#59,#60,#61,#62,#63,
                              #64,#97,#98,#99,#100,#101,#102,#103,#104,#105,#106,#107,#108,#109,#110,#111,
                              #112,#113,#114,#115,#116,#117,#118,#119,#120,#121,#122,#91,#92,#93,#94,#95,
                              #96,#97,#98,#99,#100,#101,#102,#103,#104,#105,#106,#107,#108,#109,#110,#111,
                              #112,#113,#114,#115,#116,#117,#118,#119,#120,#121,#122,#123,#124,#125,#126,#127,
                              #128,#129,#130,#131,#132,#133,#134,#135,#136,#137,#138,#139,#140,#141,#142,#143,
                              #144,#145,#146,#147,#148,#149,#150,#151,#152,#153,#154,#155,#156,#157,#158,#159,
                              #160,#161,#162,#163,#164,#165,#166,#167,#168,#169,#170,#171,#172,#173,#174,#175,
                              #176,#177,#178,#179,#180,#181,#182,#183,#184,#185,#186,#187,#188,#189,#190,#191,
                              #192,#193,#194,#195,#196,#197,#198,#199,#200,#201,#202,#203,#204,#205,#206,#207,
                              #208,#209,#210,#211,#212,#213,#214,#215,#216,#217,#218,#219,#220,#221,#222,#223,
                              #224,#225,#226,#227,#228,#229,#230,#231,#232,#233,#234,#235,#236,#237,#238,#239,
                              #240,#241,#242,#243,#244,#245,#246,#247,#248,#249,#250,#251,#252,#253,#254,#255
                            );

 Standart_WortendeZeichen:    set of char =[',','.','(','/',')','[',']','{','}',';',':','>','=','<','+','-','*','''','$','#',' ',#9];
 XML_WortendeZeichen:    set of char =[',','.','(','/',')','[',']','{','}',';','>','=','<','+','*','''','$','#','?','"','!',' ',#9];
{------------------------------------------------------------------------------}
//                          TStringLib
{------------------------------------------------------------------------------}



function TStringLib.IndexOf(const S:String):Integer;
var
  Min,Max:Integer;
  Mitte:Integer;
begin
  Min := low(StringNr);
  Max := high(StringNr);
  repeat
    //Mitte ermitteln
    Mitte := (Min + Max) div 2;
    if S > StringNr[Mitte] then
    begin  //Gesuchter String liegt oberhalb
      Min := Mitte+1;//+1 --> Mitte selbst mit ausschlieen
    end
    else
    if StringNr[Mitte] = S then
    begin //Gesuchter String wurde gefunden
      Result := Mitte;
      Exit;
    end
    else//Gesuchter String liegt unterhalb
      Max := Mitte-1;
  until (Min >= Max);
  if (Min = Max) and (StringNr[Min] = S) then Result := Min else Result := -1;
end;


procedure TStringLib.Sort;
  procedure QuickSort(iLo, iHi: Integer);
  var
    Lo, Hi: Integer;
    Mid, T:String;
  begin
    Lo := iLo;
    Hi := iHi;
    Mid := StringNr[(Lo + Hi) div 2];
    repeat
      while StringNr[Lo] < Mid do Inc(Lo);
      while StringNr[Hi] > Mid do Dec(Hi);
      if Lo <= Hi then
      begin
        T             := StringNr[Lo];
        StringNr[Lo] := StringNr[Hi];
        StringNr[Hi] := T;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo > Hi;
    if Hi > iLo then QuickSort( iLo, Hi);
    if Lo < iHi then QuickSort( Lo, iHi);
  end;
begin
  QuickSort(Low(StringNr), High(StringNr));
end;

{------------------------------------------------------------------------------}
//                        Quelltext Allegmein
{------------------------------------------------------------------------------}



Constructor TQuelltext.Create(const Strings:TStrings);
var
  I:Integer;
begin
 if (Strings = nil)  or (Strings.count = 0)then
 begin
  SetLength(Zeilen,1);
  exit;
 end;
 SetLength(Zeilen,Strings.count);
 for I := 0 to  Strings.count-1 do
 begin
  WortErmittlung(Zeilen[I],Strings[I]);
 end;
 WortErkennung(low(Zeilen),High(Zeilen));
end;

procedure TQuelltext.InsertLines(const Index,Anzahl:Integer);
var
  H:Integer;
  I:Integer;
  NewLength:Integer;
  LastInsert:Integer;
begin
 {$IFDEF ERRORCHECK}
 if (Index < low(Zeilen)) or (Index > high(Zeilen)+1) then raise Exception.Create( 'Fehler: Der Index '+ inttostr(Index)+ ' liegt nicht im Gltigen Bereich von '+ inttostr(low(Zeilen))   + ' bis ' + inttostr(high(Zeilen)+1) + ' !');
 if Anzahl <= 0 then raise Exception.Create('Fehler: Anzahl muss mindestens 1 sein.');
 {$ENDIF}
 NewLength := length(Zeilen)+Anzahl;
 if Index = high(Zeilen)+1 then
 begin
  SetLength(Zeilen,NewLength);
  SetLength(ZeilenInfo,NewLength);
 end
 else
 begin
  H := high(Zeilen);
  SetLength(Zeilen,NewLength);
  SetLength(ZeilenInfo,NewLength);
  for I:= H downto Index do
  begin
    Zeilen[I+Anzahl]:=Zeilen[I]  ;//Zeilen um Anzahl nach unten verschieben
    ZeilenInfo[I+Anzahl]:=ZeilenInfo[I]  ;//ZeilenInfo um Anzahl nach unten verschieben
  end;
  LastInsert :=  Index+Anzahl-1;
  for I:= Index to LastInsert do
  begin//Zwischenraum ausbessern.
    Zeilen[I] := nil;
    ZeilenInfo[I].BlockTyp := 0;//Startgem keine Einklappmglichkeit.
    ZeilenInfo[I].NextLine := 0;//Weder eingeklappt
    ZeilenInfo[I].Owner := 0;//Noch eingeklappt worden
  end;
 end;
end;

procedure TQuelltext.DeleteLines(const Index,Anzahl:Integer);
var
  I:Integer;
  NeuesEnde:Integer;
begin
 {$IFDEF ERRORCHECK}
 if Anzahl <= 0 then raise Exception.Create('Fehler: Anzahl muss mindestens 1 sein.');
 if (Index < low(Zeilen)) or (Index+Anzahl-1 > high(Zeilen)) then raise Exception.Create( 'Fehler: Der Index '+ inttostr(Index)+ ' liegt nicht im Gltigen Bereich von '+ inttostr(low(Zeilen))   + ' bis ' + inttostr(high(Zeilen)-Anzahl) + ' !');
 {$ENDIF}
 //Zusammen rcken
 NeuesEnde := high(Zeilen)-Anzahl;
 for I := Index to NeuesEnde do
 begin
   Zeilen[I] := Zeilen[I+Anzahl];//Zeilen verschieben
   ZeilenInfo[I] := ZeilenInfo[I+Anzahl];//ZeilenInfo verschieben
 end;
 //Neue Lnge einstellen
 SetLength(Zeilen,length(Zeilen)-Anzahl);
 SetLength(ZeilenInfo,length(Zeilen));//Lnge der Zeilen bernehmen
end;



procedure TQuelltext.WortErkennung(const Von,Bis:Integer);
var
  Index:Integer;
  OpenBracket:Integer;
  KommentarModus:Byte;
  BlockTyp:Byte;
  Unused:TUnusedParams;
begin
  if length(ZeilenInfo) <> length(Zeilen) then SetLength(ZeilenInfo,Length(Zeilen));
  if von = 0 then
  begin//Standart Einstellung fr erste Zeile
    KommentarModus := 0; //Kein Kommentar
    OpenBracket := 0;
  end
  else
  begin//Einstellungen bernehmen
    KommentarModus := ZeilenInfo[Von-1].KMode;
    OpenBracket :=  ZeilenInfo[Von-1].OpenBracket;
  end;

  {$IFDEF ERRORCHECK}
  if (Von < low(Zeilen)) or (Bis > high(Zeilen)) then raise Exception.Create(Format('Der angegebene Bereich [%d,%d] ist nicht in [%d,%d] enthalten',[Von,Bis,low(Zeilen),High(Zeilen)]));
  {$ENDIF}

  Index := Von;
  WorterkennungbeiZeile(Zeilen[Index],OpenBracket,KommentarModus,BlockTyp,Unused);

  // Liegt im Genderten Bereich oder Daten sind noch nicht gleich
  while (Index <= Bis) or ((ZeilenInfo[Index].KMode <> KommentarModus) or (ZeilenInfo[Index].OpenBracket <> OpenBracket)) do
  begin
    ZeilenInfo[Index].KMode := KommentarModus;
    ZeilenInfo[Index].OpenBracket := OpenBracket;
    ZeilenInfo[Index].Unused := Unused;

    if (ZeilenInfo[Index].BlockTyp <> 0) and  (BlockTyp = 0)//Falls eine eingeklappte Zeile ungltig wird
    and (ZeilenInfo[Index].NextLine <> 0) then
    begin
      (*
      //TODO: Zurckwandeln
      Max :=  Index + ZeilenInfo[Index].nextline;
      for I := Index+1 to Max do
      begin
        ZeilenInfo[I].Owner := 0;
        ZeilenInfo[I].NextLine := 0; //Auch enthaltene Bereiche maximieren
      end;
      ZeilenInfo[Index].NextLine := 0;//Keine Zeilen mehr berspringen   *)
      Expand(false,Index);
    end;
    ZeilenInfo[Index].BlockTyp := BlockTyp;

    //Nchste Zeile prfen
    Inc(Index);
    if Index > high(Zeilen) then break;//Nicht vorhandene Nchste Zeile nicht prfen
    WorterkennungbeiZeile(Zeilen[Index],OpenBracket,KommentarModus,BlockTyp,Unused);
  end;
end;

procedure TQuelltext.Expand(const Enabled:Boolean;Y:Integer);
var
  I:Integer;
begin
  if Enabled then
  begin
   if ZeilenInfo[Y].NextLine = 0 then //Falls sie nicht schon erweitert ist..
   begin
    ZeilenInfo[Y].NextLine := FindNextLine(Y);//Ende finden und einragen
    I := Y+1;
    while I < ZeilenInfo[Y].NextLine do
    begin
      ZeilenInfo[I].Owner := Y-I;
      I := GetNextLine(I);
    end;
    //for I := Y+1 to ZeilenInfo[Y].NextLine-1 do
    Dec(ZeilenInfo[Y].NextLine,Y)//Realative nchste Zeile
   end;
  end
  else
  begin
    I := Y+1;
    while I < ZeilenInfo[Y].NextLine+Y do
    begin
      ZeilenInfo[I].Owner := 0;
      I := GetNextLine(I);
    end;
    ZeilenInfo[Y].NextLine := 0;
  end;
end;

function TQuelltext.IsMinimized(const Y:Integer):Boolean;
begin
  result := (0 <> ZeilenInfo[Y].NextLine);
end;

function TQuelltext.CanMinimize(Y:Integer):Boolean;
begin
  result := ZeilenInfo[Y].BlockTyp <> 0;
end;

function TQuelltext.GetNextLine(Y:Integer):Integer;
begin
  //  Falls es die Zeile gibt und sie Minimierbar ist      und  die nchste Line gesetzt wurde
  if (Y < length(ZeilenInfo)) and (ZeilenInfo[Y].BlockTyp <> 0) and (ZeilenInfo[Y].NextLine > 0) then
   result := Y+ ZeilenInfo[Y].NextLine
  else
   result := Y+1;
end;
function TQuelltext.FindNextLine(const Index:Integer):Integer;//Sucht nach dem passenden End
begin
   Result := Index+1;
end;

function TQuelltext.GetLineOwner(const Y:Integer):Integer;
//Gibt den entgltigen Besitzer einer Zeile zurck
//(Besitzer = die Zeile zu der sie verkleinert wurde)
begin
  result := Y;
  while ( ZeilenInfo[result].Owner <> 0 )do
    Inc(result,ZeilenInfo[result].Owner);
end;
{------------------------------------------------------------------------------}
//                       XML Quelltext
{------------------------------------------------------------------------------}
type
  TXMLMode=(XMLM_Nichts,XMLM_Beschreibung,XMLM_OpenTag_Name,
            XMLM_OpenTag_Eigenschaften,XMLM_OpenTag_Istgleich_erwartet,
            XMLM_OpenTag_String_erwartet,XMLM_OpenTag_String,XMLM_CloseTag_Name,
            XMLM_CloseTag_Ende,XMLM_Kommentar);

procedure TXMLQuelltext.WortErkennungBeiZeile(var Zeile:TZeile;var OpenBracket:Integer;var KMode:Byte; out BlockTyp:Byte; out Unused:TUnusedParams);
var
  I:Integer;
  Mode:TXMLMode absolute KMode;
  S:String;
//const
 // CI_OpenTag=CI_Klammer2;
  //CI_CloseTag=CI_Klammer1;
  //CI_Eigenschaft=CI_GExperts;
  function KeinEnde:Boolean;
  begin
    if S = '>' then
    begin
      Zeile[I].FontIndex := CI_XML_OpenTag_Klammer;
      Mode := XMLM_Nichts;
      Result := False;
    end
    else
    if S = '/>' then
    begin
      Zeile[I].FontIndex := CI_XML_CloseTag_Klammer;
      Mode := XMLM_Nichts;
      Result := False;
    end
    else
     Result := true;
  end;
begin
  BlockTyp := 0;
  Unused[0] := 0;
  Unused[1] := 0;
  for I:= 0 to High(Zeile) do
  begin
    S := Zeile[I].Text;
    Zeile[I].FontIndex := CI_Normal;//Standartwert.
    case Mode of
     XMLM_Beschreibung:
     begin
       Zeile[I].FontIndex := CI_Compiler;
       if S = '?>' then Mode := XMLM_Nichts;
     end;
     XMLM_Kommentar:
     begin
       Zeile[I].FontIndex := CI_Kommentar;
       if S = '>' then Mode := XMLM_Nichts;
     end;
     XMLM_CloseTag_Name:
     begin
       if S = '>' then
       begin
          Mode := XMLM_Nichts;
          Zeile[I].FontIndex := CI_Fehler;
       end
       else
       begin
        Zeile[I].FontIndex := CI_Ausdruck;
        Mode := XMLM_CloseTag_Ende;
       end;
     end;
     XMLM_CloseTag_Ende:
     begin
       if S = '>' then
       begin
          Mode := XMLM_Nichts;
          Zeile[I].FontIndex := CI_XML_CloseTag_Klammer;
       end
       else
        Zeile[I].FontIndex := CI_Fehler;
     end;
     XMLM_OpenTag_Istgleich_erwartet:
     begin
       if KeinEnde then
       begin
         if S = '=' then
         begin
           Zeile[I].FontIndex := CI_Ausdruck;
           Mode := XMLM_OpenTag_String_erwartet;
         end
         else
         begin
           Zeile[I].FontIndex := CI_Fehler;
           Mode := XMLM_OpenTag_Eigenschaften;
         end;
       end;
     end;
     XMLM_OpenTag_String_erwartet:
     begin
       if KeinEnde then
       begin
         if S = '"' then
         begin
           Zeile[I].FontIndex := CI_String;
           Mode := XMLM_OpenTag_String;
         end
         else
         begin
           Zeile[I].FontIndex := CI_Fehler;
           Mode := XMLM_OpenTag_Eigenschaften;
         end;
       end;
     end;
     XMLM_OpenTag_String:
     begin
       Zeile[I].FontIndex := CI_String;
       if S = '"' then  Mode := XMLM_OpenTag_Eigenschaften;
     end;

     XMLM_OpenTag_Eigenschaften:
     begin
       if KeinEnde then
       begin
         Zeile[I].FontIndex := CI_XML_Eigenschaft;
         Mode := XMLM_OpenTag_Istgleich_erwartet;
       end;
     end;
     XMLM_OpenTag_Name:
     begin
       if KeinEnde then
       begin
         Zeile[I].FontIndex := CI_Ausdruck;
         Mode := XMLM_OpenTag_Eigenschaften;
       end;
     end;
     else
      if S = '<?' then
      begin
        Zeile[I].FontIndex := CI_Compiler;
        Mode := XMLM_Beschreibung;
      end
      else
      if S = '<' then
      begin
        Zeile[I].FontIndex := CI_XML_OpenTag_Klammer;
        Mode := XMLM_OpenTag_Name;
      end
      else
      if S = '</' then
      begin
        Zeile[I].FontIndex := CI_XML_CloseTag_Klammer;
        Mode := XMLM_CloseTag_Name;
      end
      else
      if S = '<!' then
      begin
        Zeile[I].FontIndex := CI_Kommentar;
        Mode := XMLM_Kommentar;
      end
    end;
  end;
end;

procedure TXMLQuelltext.WortErmittlung(var Zeile:TZeile;const S:String);
var Z,AZ                 : Char;
    I,WortAnfang         : Integer;
    Wortbegonnen,Zeichen,DoppelZeichen : Boolean;
    NeuesWort            : TWort;
 //berprft ob das Aktuelle Zeichen mit dem Letzten ein Doppelzeichen bildet
 function IstDoppelZeichen:Boolean;
 const
   DChar: array [0..5,0..1] of Char =(('<','/'),('/','>') ,('<','!'),('<','?'), ('?','>'), ('&','#'));
 var
   J:Integer;
 begin
  for J := 0 to high(DChar) do
  if (AZ = DChar[J,0]) and (Z = DChar[J,1]) then
  begin
   NeuesWort.Text := DChar[J,0] + DChar[J,1];
   NeuesWort.Anfang := I-1 ;
   Zeile[High(Zeile)] := NeuesWort;
   result := true;
   exit;
  end;
  result := false;
 end;
begin
 {$BOOLEVAL OFF}
 Wortbegonnen := false  ;
 WortAnfang := 0;

 SetLength(Zeile,0); //WortAnzahl := 0;
 Z := ' ';
 Zeichen := false;

 for I := 1 to Length(S) do
 begin
   AZ := Z;
   Z := S[I];
   DoppelZeichen := false;



   {--WortEnde--}
   if  (Z in  XML_WortendeZeichen) then
   begin
     if  Wortbegonnen then
     begin
       Wortbegonnen := false;
       setlength(Zeile,Length(Zeile) +1);
       NeuesWort.text := copy(S,WortAnfang, I - WortAnfang);
       NeuesWort.Anfang := WortAnfang ;
       Zeile[High(Zeile)] := NeuesWort ;
     end;

     if (Z = ' ') or (Z = #9) then Zeichen := false
     else
     begin
       if Zeichen then
       begin
         DoppelZeichen := IstDoppelZeichen;
         Zeichen := not DoppelZeichen;
       end
       else Zeichen := true;
       if Zeichen then//Zeichen zu erstellen?
       begin
         Zeichen := true;
         setlength(Zeile,Length(Zeile) +1);
         NeuesWort.Text := Z;
         NeuesWort.Anfang := I;
         Zeile[High(Zeile)] := NeuesWort ;
       end;
     end;
   end
    else Zeichen := false;//Andernfalls war es kein Zeichen

   {--Wortbeginn--}
   //durch vorherriges (Leer)Zeichen
   if not( Wortbegonnen or Zeichen or (Z = ' ') or (Z = #9)or DoppelZeichen ) and (AZ in  XML_WortendeZeichen) then
   begin
     Wortbegonnen := true ;
     WortAnfang := I;
   end;
 end;
 if Wortbegonnen then //Noch nicht fertige Wrter fertigstellen
 begin
   setlength(Zeile,Length(Zeile) +1);
   NeuesWort.text := copy(S,WortAnfang, Length(S)+1 - WortAnfang);
   NeuesWort.Anfang := WortAnfang ;
   Zeile[High(Zeile)] := NeuesWort ;
 end;
end;


{------------------------------------------------------------------------------}
//                       Delphi Quelltext
{------------------------------------------------------------------------------}
type
  TDelphiKommentarModus=(skm_kein_Kommentar,skm_type_kein_Kommentar,skm_Klammer_Kommentar,skm_Stern_Kommentar,skm_DoppelStrich_Kommentar,skm_Compiler_Direktive,skm_GExperts_Kommentar,skm_CodeEditor_Kommentar);

  TDelphiAusdruck=(
  DA_Unbekannt,DA_keiner,DA_begin,DA_end,DA_record,DA_asm,DA_case,DA_try,
  DA_KlammerAuf,DA_KlammerZu,DA_Apostroph,DA_Strichpunkt,
  DA_Stern_Kommentar_Anfang,DA_Stern_Kommentar_Ende,
  DA_Klammer_Kommentar_Anfang,DA_Klammer_Kommentar_Ende,
  DA_DoppelStrich_Kommentar,DA_Compiler_Direktive_Anfang,
  DA_CodeEditor_Kommentar_Anfang,DA_GExperts_Kommentar_Anfang,
  DA_region,DA_endregion

  );

  TDelphiStringLib=class(TStringLib)
  private
    TypVonNr:array of TDelphiAusdruck;
  public
    function Typ(const S:String):TDelphiAusdruck;
    constructor Create;
  end;

const
  BeginEnd_Block=1;
  Region_Block=2;
var
  DelphiStringLib:TDelphiStringLib;
constructor TDelphiStringLib.Create;
const
  AusdruckAnzahl=107;//Vorher 66
var
  I:Integer;
begin
  SetLength(StringNr,AusdruckAnzahl);
  SetLength(TypvonNr,AusdruckAnzahl);
  for I := low(TypvonNr) to high(TypvonNr) do TypVonNr[I] := DA_Unbekannt;


  I := 0;  StringNr[I] := 'begin';
  Inc(I);  StringNr[I] := 'end';
  Inc(I);  StringNr[I] := 'asm';
  Inc(I);  StringNr[I] := 'else';
  Inc(I);  StringNr[I] := 'if';
  Inc(I);  StringNr[I] := 'then';
  Inc(I);  StringNr[I] := 'else';
  Inc(I);  StringNr[I] := 'or';
  Inc(I);  StringNr[I] := 'and';
  Inc(I);  StringNr[I] := 'not';
  Inc(I);  StringNr[I] := 'for';
  Inc(I);  StringNr[I] := 'to';
  Inc(I);  StringNr[I] := 'do';
  Inc(I);  StringNr[I] := 'while';
  Inc(I);  StringNr[I] := 'with';
  Inc(I);  StringNr[I] := 'var';
  Inc(I);  StringNr[I] := 'string';
  Inc(I);  StringNr[I] := 'array';
  Inc(I);  StringNr[I] := 'of';
  Inc(I);  StringNr[I] := 'property';
  Inc(I);  StringNr[I] := 'read';
  Inc(I);  StringNr[I] := 'write';
  Inc(I);  StringNr[I] := 'constructor';
  Inc(I);  StringNr[I] := 'destructor';
  Inc(I);  StringNr[I] := 'type';
  Inc(I);  StringNr[I] := 'const';
  Inc(I);  StringNr[I] := 'class';
  Inc(I);  StringNr[I] := 'private';
  Inc(I);  StringNr[I] := 'protected';
  Inc(I);  StringNr[I] := 'public';
  Inc(I);  StringNr[I] := 'published';
  Inc(I);  StringNr[I] := 'function';
  Inc(I);  StringNr[I] := 'procedure';
  Inc(I);  StringNr[I] := 'as';
  Inc(I);  StringNr[I] := 'is';
  Inc(I);  StringNr[I] := 'uses';
  Inc(I);  StringNr[I] := 'finally';
  Inc(I);  StringNr[I] := 'except';
  Inc(I);  StringNr[I] := 'interface';
  Inc(I);  StringNr[I] := 'inherited';
  Inc(I);  StringNr[I] := 'virtual';
  Inc(I);  StringNr[I] := 'unit';
  Inc(I);  StringNr[I] := 'program';
  Inc(I);  StringNr[I] := 'abstract';
  Inc(I);  StringNr[I] := 'object';
  Inc(I);  StringNr[I] := 'case';
  Inc(I);  StringNr[I] := 'implementation';
  Inc(I);  StringNr[I] := 'finalization';
  Inc(I);  StringNr[I] := 'repeat';
  Inc(I);  StringNr[I] := 'until';
  Inc(I);  StringNr[I] := 'record';
  Inc(I);  StringNr[I] := 'try';
  Inc(I);  StringNr[I] := '(';
  Inc(I);  StringNr[I] := ')';
  Inc(I);  StringNr[I] := '(*';
  Inc(I);  StringNr[I] := '*)';
  Inc(I);  StringNr[I] := '//';
  Inc(I);  StringNr[I] := '{.';
  Inc(I);  StringNr[I] := '{#';
  Inc(I);  StringNr[I] := '{$';
  Inc(I);  StringNr[I] := '{';
  Inc(I);  StringNr[I] := '}';
  Inc(I);  StringNr[I] := '''';
  Inc(I);  StringNr[I] := ';';
  Inc(I);  StringNr[I] := 'region';
  Inc(I);  StringNr[I] := 'endregion';
  Inc(I);  StringNr[I] := 'in';
  Inc(I);  StringNr[I] := 'on';
  Inc(I);  StringNr[I] := 'far';
  Inc(I);  StringNr[I] := 'xor';
  Inc(I);  StringNr[I] := 'div';
  Inc(I);  StringNr[I] := 'set';
  Inc(I);  StringNr[I] := 'nil';
  Inc(I);  StringNr[I] := 'out';
  Inc(I);  StringNr[I] := 'shl';
  Inc(I);  StringNr[I] := 'shr';
  Inc(I);  StringNr[I] := 'mod';
  Inc(I);  StringNr[I] := 'file';
  Inc(I);  StringNr[I] := 'goto';
  Inc(I);  StringNr[I] := 'near';
  Inc(I);  StringNr[I] := 'label';
  Inc(I);  StringNr[I] := 'cdecl';
  Inc(I);  StringNr[I] := 'raise';
  Inc(I);  StringNr[I] := 'downto';
  Inc(I);  StringNr[I] := 'packed';
  Inc(I);  StringNr[I] := 'inline';
  Inc(I);  StringNr[I] := 'dispid';
  Inc(I);  StringNr[I] := 'pascal';
  Inc(I);  StringNr[I] := 'export';
  Inc(I);  StringNr[I] := 'library';
  Inc(I);  StringNr[I] := 'stdcall';
  Inc(I);  StringNr[I] := 'dynamic';
  Inc(I);  StringNr[I] := 'forward';
  Inc(I);  StringNr[I] := 'message';
  Inc(I);  StringNr[I] := 'external';
  Inc(I);  StringNr[I] := 'register';
  Inc(I);  StringNr[I] := 'safecall';
  Inc(I);  StringNr[I] := 'overload';
  Inc(I);  StringNr[I] := 'override';
  Inc(I);  StringNr[I] := 'absolute';
  Inc(I);  StringNr[I] := 'automated';
  Inc(I);  StringNr[I] := 'assembler';
  Inc(I);  StringNr[I] := 'threadvar';
  Inc(I);  StringNr[I] := 'reintroduce';
  Inc(I);  StringNr[I] := 'dispinterface';
  Inc(I);  StringNr[I] := 'initialization';
  Inc(I);  StringNr[I] := 'resourcestring';

  // Dann wird sortiert
  Sort;
  // Nachdem sortiert wurde ist IndexOf funktions tchtig
  // und es kann der Typ festgelegt werden;
  try
  TypVonNr[IndexOf('begin')] := DA_begin;
  TypVonNr[IndexOf('end')] := DA_end;
  TypVonNr[IndexOf('asm')] := DA_asm;
  TypVonNr[IndexOf('try')] := DA_try;
  TypVonNr[IndexOf('record')] := DA_record;
  TypVonNr[IndexOf('case')] := DA_case;
  TypVonNr[IndexOf('(')] := DA_KlammerAuf;
  TypVonNr[IndexOf(')')] := DA_KlammerZu;
  TypVonNr[IndexOf('(*')] := DA_Stern_Kommentar_Anfang;
  TypVonNr[IndexOf('*)')] := DA_Stern_Kommentar_Ende;
  TypVonNr[IndexOf('{')] := DA_Klammer_Kommentar_Anfang;
  TypVonNr[IndexOf('}')] := DA_Klammer_Kommentar_Ende;
  TypVonNr[IndexOf('//')] := DA_DoppelStrich_Kommentar;
  TypVonNr[IndexOf('{$')] := DA_Compiler_Direktive_Anfang;
  TypVonNr[IndexOf('{.')] := DA_CodeEditor_Kommentar_Anfang;
  TypVonNr[IndexOf('{#')] := DA_GExperts_Kommentar_Anfang;
  TypVonNr[IndexOf('''')] := DA_Apostroph;
  TypVonNr[IndexOf(';')] := DA_Strichpunkt;
  TypVonNr[IndexOf('region')] := DA_region;
  TypVonNr[IndexOf('endregion')] := DA_endregion;
  except
    on ERangeError do MessageBox(0, 'Error: Delphi-Ausdruck nicht vorhanden.', 'Error', MB_ICONERROR or MB_OK);
  end;
end;

function TDelphiStringLib.Typ(const S:String):TDelphiAusdruck;
var
  Index:Integer;
begin
  Index := IndexOf(S);
  if Index = -1 then Result := DA_keiner else Result := TypvonNr[Index];
end;

procedure TDelphiQuelltext.Wortermittlung(var Zeile:TZeile;const S:String);
var Z,AZ                 : Char;
    I,WortAnfang         : Integer;
    Wortbegonnen,Zeichen,DoppelZeichen : Boolean;
    NeuesWort            : TWort;
 //berprft ob das Aktuelle Zeichen mit dem Letzten ein Doppelzeichen bildet
 function IstDoppelZeichen:Boolean;
 const
   DChar: array [0..8,0..1] of Char =((':','='),('/','/') ,('>','='),('<','='), ('(','*'), ('*',')'),('{','$'),('{','#'),('{','.') );
 var
   J:Integer;
 begin
  for J := 0 to high(DChar) do
  if (AZ = DChar[J,0]) and (Z = DChar[J,1]) then
  begin
   NeuesWort.Text := DChar[J,0] + DChar[J,1];
   NeuesWort.Anfang := I-1 ;
   //setlength(Zeile,Length(Zeile) +1);
   Zeile[High(Zeile)] := NeuesWort;
   Zeichen := true ;
   result := true;
   exit;
  end;
  result := false;
 end;
begin
 {$BOOLEVAL OFF}
 Wortbegonnen := false  ;
 WortAnfang := 0;

 SetLength(Zeile,0); //WortAnzahl := 0;
 Z := ' ';
 Zeichen := false;

 for I := 1 to Length(S) do
 begin
   AZ := Z;
   Z := S[I];
   DoppelZeichen := false;



   {--WortEnde--}
   if  (Z in Standart_WortEndeZeichen) then
   begin
     if  Wortbegonnen then
     begin
       Wortbegonnen := false;
       setlength(Zeile,Length(Zeile) +1);
       NeuesWort.text := copy(S,WortAnfang, I - WortAnfang);
       NeuesWort.Anfang := WortAnfang ;
       Zeile[High(Zeile)] := NeuesWort ;
     end;

     if (Z = ' ') or (Z = #9) then Zeichen := false
     else
     begin
       if Zeichen then
       begin
         DoppelZeichen := IstDoppelZeichen;
         Zeichen := not DoppelZeichen;
       end
       else Zeichen := true;
       if Zeichen then//Zeichen zu erstellen?
       begin
         Zeichen := true;
         setlength(Zeile,Length(Zeile) +1);
         NeuesWort.Text := Z;
         NeuesWort.Anfang := I;
         Zeile[High(Zeile)] := NeuesWort ;
       end;
     end;
   end
    else Zeichen := false;//Andernfalls war es kein Zeichen

   {--Wortbeginn--}
   //durch vorherriges (Leer)Zeichen
   if not( Wortbegonnen or Zeichen or (Z = ' ') or (Z = #9)or DoppelZeichen ) and (AZ in Standart_WortEndeZeichen) then
   begin
     Wortbegonnen := true ;
     WortAnfang := I;
   end;
 end;
 if Wortbegonnen then //Noch nicht fertige Wrter fertigstellen
 begin
   setlength(Zeile,Length(Zeile) +1);
   NeuesWort.text := copy(S,WortAnfang, Length(S)+1 - WortAnfang);
   NeuesWort.Anfang := WortAnfang ;
   Zeile[High(Zeile)] := NeuesWort ;
 end;



end;

procedure TDelphiQuelltext.WortErkennungBeiZeile(var Zeile:TZeile;var OpenBracket:Integer;var KMode:Byte; out BlockTyp:Byte; out Unused:TUnusedParams);
var
  S:String;
  procedure NurKleinBuchstaben;
  var
    I:Integer;
  begin
    for I:= 1 to Length(S) do S[I]:= sChar[S[I]] ;
  end;
var
  I:Integer;
  StringMode:Boolean;
  BeginEndChange:Integer;
  RegionChange:Integer;
  KommentarModus:TDelphiKommentarModus absolute KMode;
  Ausdruck:TDelphiAusdruck;
begin
  Unused[0] := 0;
  Unused[1] := 0;
  BeginEndChange := Unused[0];
  RegionChange:= Unused[1];
  BlockTyp := 0;
  StringMode := false;
  if KommentarModus = skm_DoppelStrich_Kommentar then KommentarModus := skm_Kein_Kommentar;
  for I:=  0 to High(Zeile) do
  begin
    S:= Zeile[I].text;
    NurKleinBuchstaben;
    Ausdruck := DelphiStringLib.Typ(S);
    Zeile[I].FontIndex := CI_Normal;
    if StringMode then
    begin
      Zeile[I].FontIndex := 3;
      // String-Ende bei '
      if Ausdruck = DA_Apostroph then StringMode := false;
    end
    else
    case KommentarModus of
     skm_DoppelStrich_Kommentar: Zeile[I].FontIndex := 2;
     skm_Klammer_Kommentar:
     begin
       Zeile[I].FontIndex := CI_Kommentar;
       //Kommentar-Ende bei }
       if Ausdruck = DA_Klammer_Kommentar_Ende then KommentarModus := skm_kein_Kommentar;
     end;
     skm_Compiler_Direktive:
     begin
       Zeile[I].FontIndex := CI_Compiler;
       //Kommentar-Ende bei }
       if Ausdruck = DA_Klammer_Kommentar_Ende then KommentarModus := skm_kein_Kommentar;
     end;
     skm_GExperts_Kommentar:
     begin
       Zeile[I].FontIndex := CI_GExperts;
       //Kommentar-Ende bei }
       if Ausdruck = DA_Klammer_Kommentar_Ende then KommentarModus := skm_kein_Kommentar;
     end;
     skm_CodeEditor_Kommentar:
      begin
        Zeile[I].FontIndex := CI_CodeEditor_Normal;
        NurKleinBuchstaben;
        Case Ausdruck of
         DA_Klammer_Kommentar_Ende:// '}'
          begin
            KommentarModus := skm_kein_Kommentar;
          end;
         DA_region:
          begin
            Zeile[I].FontIndex := CI_CodeEditor_Ausdruck;
            if BlockTyp = 0 then BlockTyp := Region_Block;
            Inc(RegionChange);
          end;
         DA_endregion:
          begin
            Zeile[I].FontIndex := CI_CodeEditor_Ausdruck;
            Dec(RegionChange);
          end;
        end;
      end;
     skm_Stern_Kommentar:
      begin
        if Ausdruck = DA_Stern_Kommentar_Ende then KommentarModus := skm_kein_Kommentar;
        Zeile[I].FontIndex := CI_Kommentar;
      end;
     else
      begin
        Case Ausdruck of
         DA_keiner: Zeile[I].FontIndex := CI_Normal;
         DA_Unbekannt: Zeile[I].FontIndex := CI_Ausdruck;
         DA_DoppelStrich_Kommentar: // '//'
          begin
            Zeile[I].FontIndex := CI_Kommentar;
            KommentarModus := skm_DoppelStrich_Kommentar;
          end;
         DA_Stern_Kommentar_Anfang:// '(*'
          begin
            Zeile[I].FontIndex := CI_Kommentar;
            KommentarModus := skm_Stern_Kommentar;
          end;
         DA_Klammer_Kommentar_Anfang:// '{'
          begin
            Zeile[I].FontIndex := CI_Kommentar;
            KommentarModus := skm_Klammer_Kommentar;
          end;
         DA_Compiler_Direktive_Anfang:// '{$'
          begin
            Zeile[I].FontIndex := CI_Compiler;
            KommentarModus := skm_Compiler_Direktive;
          end;
         DA_GExperts_Kommentar_Anfang://'{#'
          begin
            Zeile[I].FontIndex := CI_GExperts;
            KommentarModus := skm_GExperts_Kommentar;
          end;
         DA_CodeEditor_Kommentar_Anfang://'{.'
          begin
            Zeile[I].FontIndex := CI_CodeEditor_Normal;
            KommentarModus := skm_CodeEditor_Kommentar;
          end;
         DA_Apostroph: // '
          begin
            StringMode := true;
            Zeile[I].FontIndex := CI_String;
          end;
         DA_KlammerAuf: // '('
          begin
            Inc(OpenBracket);
            Zeile[I].FontIndex := (OpenBracket+2) mod 3 + CI_Klammer0;
          end;
         DA_KlammerZu: // ')'
          begin
            if OpenBracket <= 0 then Zeile[I].FontIndex := CI_Klammer0
            else
             Zeile[I].FontIndex := (OpenBracket+2) mod 3 + CI_Klammer0;
            Dec(OpenBracket);
          end;
         DA_Strichpunkt:// ';'
          begin
            Zeile[I].FontIndex := CI_Normal;
            OpenBracket := 0;//Es gibt kein ';' innerhalb einer normalen Klammer.
          end;
         DA_begin,DA_try,DA_asm:
          begin
            Zeile[I].FontIndex := CI_Ausdruck;
            if BlockTyp = 0 then BlockTyp := BeginEnd_Block;
            Inc(BeginEndChange);
          end;
         DA_record:
          begin
            Zeile[I].FontIndex := CI_Ausdruck;
            Inc(BeginEndChange);
            KommentarModus := skm_type_kein_Kommentar;
          end;
         DA_case:
          if (KommentarModus <> skm_type_kein_Kommentar) then
          begin
            Zeile[I].FontIndex := CI_Ausdruck;
            if BlockTyp = 0 then BlockTyp := BeginEnd_Block;
            Inc(BeginEndChange);
            KommentarModus := skm_type_kein_Kommentar;
          end;
         DA_end:
          begin
            Zeile[I].FontIndex := CI_Ausdruck;
            Dec(BeginEndChange);
            if BeginEndChange <= 0 then KommentarModus := skm_kein_Kommentar;
            //Vorsicht Klassen,UnitEnde und Schnittstellen werden nicht beachten
          end;
         else //Nicht wirkende Ausdrcke (wie etwa '*)' auerhalb eines Kommentars )
          Zeile[I].FontIndex := CI_Normal;
        end;//Von "Case Ausdruck of"
      end;
    end;
  end;
  Unused[0] := BeginEndChange ;
  Unused[1] := RegionChange;
end;



function TDelphiQuelltext.FindNextEnd(const Index:Integer):Integer;  //Sucht nach dem Ende end
var
  BeginEndState:Integer;
begin
  BeginEndState := ZeilenInfo[Index].Unused[0];
  result := Index;
  while (BeginEndState > 0)do//Solange der Begin-End Block offen ist...
  begin
    if result >= length(ZeilenInfo) then
    begin //Kein Ende gefunden
      result := Index+1; //Einfach nchste Zeile zurckgeben
      exit;
    end;
    Inc(result);//Nchste Zeile prfen
    //Vernderungen der nchsten Zeile:
    Inc(BeginEndState,ZeilenInfo[result].Unused[0]);
  end;
  result := result+1;//End  mit einbeziehen
end;

function TDelphiQuelltext.FindNextEndRegion(const Index:Integer):Integer;  //Sucht nach dem Ende EndRegion
var
  RegionState:Integer;
begin
  RegionState := ZeilenInfo[Index].Unused[1];
  result := Index;
  while (RegionState > 0)do//Solange der Regions Block offen ist...
  begin
    if result >= length(ZeilenInfo) then
    begin //Kein Ende gefunden
      result := Index+1; //Einfach nchste Zeile zurckgeben
      exit;
    end;
    Inc(result);//Nchste Zeile prfen
    //Vernderungen der nchsten Zeile:
    Inc(RegionState,ZeilenInfo[result].Unused[1]);
  end;
  result := result+1;//EndRegion  mit einbeziehen
end;

function TDelphiQuelltext.FindNextLine(const Index:Integer):Integer; //Sucht nach dem passenden Ende
begin
  case ZeilenInfo[Index].BlockTyp of
   0,BeginEnd_Block:
   begin
      result := FindNextend(Index);
   end;
   Region_Block:
   begin
      result := FindNextendregion(Index);
   end;
   else result := Index +1;
  end;
end;

initialization
  DelphiStringLib := TDelphiStringLib.Create;
finalization
  DelphiStringLib.Free;
end.
