(***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Original Code is ReplaceDialogUnit.pas

The Initial Developer of the Original Code is
Florian Kberle. (eMail:FloriansKarten@web.de)
Portions created by the Initial Developer are Copyright (C) 2005
the Initial Developer. All Rights Reserved.

Contributor(s):

***** END LICENSE BLOCK *****)
unit ReplaceDialogUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;
type
 TSuchAnfang=(SA_TextAnfang,SA_MarkierungsEnde,SA_MarkierungsAnfang);
 TSuchEnde=  (SE_TextEnde,SE_MarkierungsEnde,SE_MarkierungsAnfang);

type
  TReplaceForm = class(TForm)
    EditFind: TEdit;
    CheckBoxSize: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    EditReplace: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    RadioGroupStart: TRadioGroup;
    RadioGroupBereich: TRadioGroup;
    BitBtnAlles: TBitBtn;
    procedure BitBtn2Click(Sender: TObject);
    function Ersetzen(Von:TSuchAnfang;Bis:TSuchEnde;Alles:Boolean):Boolean;
    procedure RadioGroupBereichClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  ReplaceForm: TReplaceForm;

implementation
uses CodeEditorFormUnit,CodeEditor;
{$R *.DFM}
function TReplaceForm.Ersetzen(Von:TSuchAnfang;Bis:TSuchEnde;Alles:Boolean):Boolean;
var
  X,Y:Integer;
  CEditor:TCodeEditor;
  SuchText:String;
  RText:String;
  Text:String;
  VonX,VonY:Integer;
  BisX,BisY:Integer;
  Nothing:Integer;
  high_Lines:Integer;
begin
  Result := false;
  SuchText := EditFind.Text;
  RText := EditReplace.text;
  if not CheckBoxSize.Checked then SuchText := LowerCase(SuchText);
  CEditor := CodeEditorFormUnit.FloriansCodeEditorForm.GetActiveCodeEditor;
  high_Lines := CEditor.Lines.Count-1;
  if high_Lines = -1 then  Exit;


  Case Von of
  SA_TextAnfang:
    begin
      VonX := 0;
      VonY := 0;
    end;
   SA_MarkierungsAnfang:
    CEditor.GetSelection(VonX,VonY,Nothing,Nothing);
   SA_MarkierungsEnde:
    CEditor.GetSelection(Nothing,Nothing,VonX,VonY);
  end;

  Case Bis of
   SE_TextEnde:
    begin
     BisX := 1000000;
     BisY :=  CEditor.Lines.Count-1;
    end;
   SE_MarkierungsAnfang:
    CEditor.GetSelection(BisX,BisY,Nothing,Nothing);
   SE_MarkierungsEnde:
    CEditor.GetSelection(Nothing,Nothing,BisX,BisY);
  end;

  //Im hinteren Teil der ersten Zeile suchen
  Y := VonY;
  Text := CEditor.Lines[Y] ;
  Text := Copy(Text,VonX+1,length(Text));//Vordern Teil wegschneiden
  if not CheckBoxSize.Checked then Text  := LowerCase(Text);
  X := Pos(SuchText,Text);
  if X <> 0 then
  begin
    X := X+VonX;//Den Weggeschnittenen Teil mitzhlen
    CEditor.Menu_GoTo(X-1,Y,false);
    CEditor.Menu_ReplaceText(Y,X-1,length(SuchText),RText,not Alles);
    Result := true;
    if not Alles then Exit;
  end;

  //Den Rest durchsuchen;
  Inc(Y);
  if Y > high_Lines then Y := 0;
  while (Y <> BisY) do
  begin
    Text := CEditor.Lines[Y];
    if not CheckBoxSize.Checked then Text  := LowerCase(Text);
    X := Pos(SuchText,Text);
    if (X <> 0) then
    begin
      CEditor.Menu_GoTo(X-1,Y,false);
      CEditor.Menu_ReplaceText(Y,X-1,length(SuchText),RText,not Alles);
      Result := true;
      if not Alles then Exit;
    end;
    Inc(Y);
    if Y > high_Lines then Y := 0;
  end;


  //Letzte Zeile berprfen
  Text := CEditor.Lines[BisY];
  if not CheckBoxSize.Checked then Text  := LowerCase(Text);
  X := Pos(SuchText,Text);
  if (X <> 0) and (X < BisX) then
  begin
    CEditor.Menu_GoTo(X-1,Y,false);
    CEditor.Menu_ReplaceText(Y,X-1,length(SuchText),RText,not Alles);
    result := true;
    if not Alles then Exit;
  end;
  if result then CEditor.Refresh;
end;

procedure TReplaceForm.BitBtn2Click(Sender: TObject);
var
  SuchAnfang:TSuchAnfang;
  SuchEnde:TSuchEnde;
begin
  if RadioGroupBereich.ItemIndex = 0 then  //Gesamter Text
  begin
    if RadioGroupStart.ItemIndex = 0 then //Ab Cursor
    begin
      SuchAnfang := SA_MarkierungsAnfang;
      SuchEnde := SE_MarkierungsAnfang;
    end
    else //TextAnfang
    begin
      SuchAnfang := SA_TextAnfang;
      SuchEnde := SE_TextEnde;
    end;
  end
  else //Markierter Text
  begin
    SuchAnfang := SA_MarkierungsAnfang;
    SuchEnde := SE_MarkierungsEnde;
  end;

  if not Ersetzen(SuchAnfang,SuchEnde,Sender = BitBtnAlles) then
  MessageBox(0, 'Suche ergab keine Treffer', 'Hinweis', MB_ICONINFORMATION or MB_OK);
end;

procedure TReplaceForm.RadioGroupBereichClick(Sender: TObject);
begin
  RadioGroupStart.enabled := (RadioGroupBereich.ItemIndex = 0);
end;

end.
